// pr437_1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <cmath>
#include <valarray>

#include <conio.h>   //  getch()

using namespace std;

//     
template<class T>
void printValarray3D (const valarray<T>& va, int dim1, int dim2)
{
    for (int i=0; i < va.size()/(dim1*dim2); ++i) {
        for (int j=0; j<dim2; ++j) {
            for (int k=0; k<dim1; ++k) {
                cout << va[i*dim1*dim2+j*dim1+k] << ' ';
            }
            cout << '\n';
        }
        cout << '\n';
    }
    cout << endl;
}

int _tmain(int argc, _TCHAR* argv[])
{
  locale::global(locale("rus"));
  //    24 
  //   -  
  //   -  
  //   -  
  valarray<double> va(24);

  //    
  for (int i=0; i<24; i++) {
      va[i] = i;
  }

  //   
  cout << " :\n"; 
  printValarray3D (va, 3, 4);

  //      3x3 
  //   12- 
  size_t lengthvalues[] = {  2, 3 };
  size_t stridevalues[] = { 12, 3 };
  valarray<size_t> length(lengthvalues,2);
  valarray<size_t> stride(stridevalues,2);

  //      
  //     
  va[gslice(0,length,stride)]
      = valarray<double>(va[gslice(1,length,stride)]);

  //        
  //     
  va[gslice(0,length,stride)]
      += valarray<double>(va[gslice(2,length,stride)]);
    
  //   
  cout << "  :\n"; 
  printValarray3D (va, 3, 4);


  getch();
  return 0;
}

